using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class RawImageScript : MonoBehaviour
{
    // R|[lgϐ
    private RawImage m_rawimage;

    // o[ϐ
    private AndroidJavaObject m_ajoSurfaceTextureRenderer;
    private bool m_bPlaying;

    // Start is called before the first frame update
    void Start()
    {
        m_rawimage = GetComponent<RawImage>();

        // eNX`[̍쐬
        // filterMode : 摜̕ԕ@w肷BPoint = ⊮ȂB̑ÍABilinearATrilinearB 
        Texture2D texture2d = new Texture2D( 512, 512, TextureFormat.ARGB32, false, false );
        texture2d.filterMode = FilterMode.Point;

        // UnityRawImagẽeNX`ƂĐݒ
        m_rawimage.texture = texture2d;
    }

    // Update is called once per frame
    void Update()
    {
        if( null != m_ajoSurfaceTextureRenderer )
        {
            // eNX`XV
            m_ajoSurfaceTextureRenderer.Call( "updateSurfaceTexture" );
        }
    }

    // Cxg
    public void OnEvent()
    {
        if( null == m_ajoSurfaceTextureRenderer )
        {
            // ́ATextureRendererB
            InitializeTextureRenderer( 512, 512 );
        }

        // Surfaceł̕`
        if( m_bPlaying )
        {
            m_ajoSurfaceTextureRenderer.Call( "stopDrawInSurface" );
            m_bPlaying = false;
        }
        else
        {
            m_ajoSurfaceTextureRenderer.Call( "startDrawInSurface" );
            m_bPlaying = true;
        }
    }

    // TextureRendereȑ
    public void InitializeTextureRenderer( int iTextureWidth, int iTextureHeight )
    {
        Debug.Log( "InitializeTextureRenderer() start" );

        // eNX`ID̎擾ƃoϐւ̐ݒ
        IntPtr intptrTextureID = ((Texture2D)m_rawimage.texture).GetNativeTexturePtr();
        Debug.Log( "  intptrTextureID = " + intptrTextureID.ToString() );

        // SurfaceTextureRendererIuWFNg̐
        m_ajoSurfaceTextureRenderer = new AndroidJavaObject( "com.hiramine.surfacetexturerenderer.SurfaceTextureRenderer",
            iTextureWidth,
            iTextureHeight,
            intptrTextureID.ToInt32() );    // UnityeNX`gp
        Debug.Log( "  m_ajoSurfaceTextureRenderer = " + m_ajoSurfaceTextureRenderer.ToString() );

        // Rendereȑ
        m_ajoSurfaceTextureRenderer.Call( "init" );

        Debug.Log( "InitializeTextureRenderer() end" );
    }
}
